import { WebGPUObjectError } from '../utils/errors.js'

export class ShaderModule {
  _handle

  get label() {
    return this._handle.label
  }

  get handle() {
    return this._handle
  }

  /**
   * @param {GPUShaderModule} module
   */
  constructor(module) {
    this._handle = module
  }

  /**
   * @param {GPUDevice} device
   * @param {GPUShaderModuleDescriptor} descriptor
   */
  static create(device, descriptor) {
    try {
      return new ShaderModule(
        device.createShaderModule(descriptor)
      )
    } catch (err) {
      throw WebGPUObjectError.from(err, ShaderModule)
    }
  }
}

